# GNTool 2
#
# By:    Zsac
# Email: virus23@digitalops.com
# URL:	 http://clani69.digitalops.com/tcl/
#
# My revision of the outdated GNTool script. This script does
# all the same stuff GNTool but in a simpler easier to read way.
# It also ditches the revenge stuff asside from the actions that
# are done through chanserv. The commands now are also MUCH
# easier to change in case of future changes to gamesnet...
# or if you want to try porting this script to another server
# it would be much simpler now. The script now also supports
# allowing the bot to join rooms where it has been key'ed or 
# limitted out. enjoy.
#
# Commands: .gn_reg .gn_unreg - un/registers your both with gamesnet
# 		.gn_cookie .gn_help
# Installation:
#	1) add this file to your eggies conf
#	2) config the file (below)
#	3) .gn_reg in a dcc chat with the bot to register with gamesnet
#	4) check your email, get your cookie. put it in the config below
#	5) .gn_cookie in a dcc chat with the bot
#	and now your bot should register with gamesnet.
#
################################################################

# the name of the service the bot interacts with
set gn_servicename 	"ChanServ"

# the address of the chanserv service (for secure msging)
set gn_servicecaddy 	"ChanServ@Services.GamesNET.net"

# the address of the authserv service (for secure msging)
set gn_serviceaaddy 	"AuthServ@Services.GamesNET.net"

# the chans this script will work on
set gn_chans 		"#clani69 #i69priv #testingabc"

# the account in which your eggdrop is registered under. only set this
# if your eggdrop's nickname is different than the account name. otherwise
# leave this empty
set gn_account 		"Zegg"

# COMMANDS ##################
# Key:
#	xchan = channel
#	xnick = nickname
#	xpass = password for auth
#	xemail= email addy for registering
#	xcookie= cookie for registering
# unban #####################
set gn_requnban1 		"UNBAN xchan xnick"
# auth ######################
set gn_reqauth1  		"AUTH xnick xpass"
# invite ####################
set gn_reqinvite1		"INVITE xchan xnick"
# op ########################
set gn_reqop1 			"OP xchan xnick"
# open chan #################
set gn_reqlimkey1		"OPEN xchan"
# register ##################
set gn_reqreg1			"REGISTER xnick xpass xemail"
# unregister ################
set gn_requnreg1		"UNREGISTER xpass"
# cookie ####################
set gn_reqc1 			"COOKIE xnick xcookie"
#############################

# the bots password
set gn_pass 	"password"
# the bots email addy
set gn_email 	"your@email"
# the cookie
set gn_cookie 	"cookie"


# the interval to check if chanserv is fighting 
# with the bot. measured in seconds
set gn_chancheck 5

# interval to check the service type of a room. this
# is here cause sometimes when your egg joins it
# might be under a netsplit and the service is on
# another split server. this ensures that things will
# be set right. measured in minutes
set gn_servicecheck 3

# interval to renew auth with services. measured in minutes
set gn_authrefresh 175

################################################################

set gn_services(none) "none"
set gn_timers(none) "none"

bind join -|- * 	gn_needjoined
bind need -|- *unban* 	gn_needunban
bind need -|- *op* 	gn_needop
bind need -|- *invite*  gn_needinvite
bind need -|- *key*	gn_needkl
bind need -|- *limit*	gn_needkl
bind dcc  n|n gn_reg	gn_needreg
bind dcc  n|n gn_unreg	gn_needunreg
bind dcc  n|n gn_cookie gn_needcookie
bind dcc  n|n gn_help 	gn_help
bind dcc  n|n gn_debug	gn_debug

proc gn_debug { hand id args } {
	global gn_services gn_timers

	putlog "GNTOOL: Service Settings"
	for { set x 0 } { $x < [llength [channels]] } { incr x } {
		putlog "  [lindex [channels] $x]: [lindex [array get gn_services [lindex [channels] $x]] 1]"
		putlog "     check: [lindex [array get gn_timers [lindex [channels] $x]] 1]"
	}

	putlog "GNTOOL: Timer Settings"
	putlog "  checkchanserv: [lindex [array get gn_timers 0] 1]"
	putlog "  refreshauth:   [lindex [array get gn_timers 1] 1]"
}

# help
proc gn_help { hand id args } {
	putlog ".gn_reg    - registers with gamesnet."
	putlog ".gn_unreg  - unregisters with gamesnet."
	putlog ".gn_cookie - gives the cookie to gamesnet."
}

# returns a 1 if the current channel is a channel this script should work on
proc gn_needchan { chan } {
	global gn_chans

	if { [lsearch -all $gn_chans $chan] < 0 } {
		return 0 
	} else {
		return 1
	}
}

# attempts to prevent chanserv from being on the bots enemy list
proc gn_checkchanserv { } {
	global gn_chancheck gn_servicename

	for { set x 0 } { $x < [llength [channels]] } { incr x } {
		set chan [lindex [channels] $x]

		if { [matchattr [finduser *![getchanhost $gn_servicename]] kd|kd $chan] == 1 } { 
			putlog "GNTool: $gn_servicename found +d/+k on $chan. Removing flag."
			chattr [finduser *![getchanhost $gn_servicename]] |-dk $chan
			chattr [finduser *![getchanhost $gn_servicename]] -dk
			chattr [finduser *![getchanhost $gn_servicename]] +fo
		}
	}

	utimer $gn_chancheck "gn_checkchanserv"
}

# formats strings for commands
proc gn_stringsub { string chan } {
	global botnick gn_pass gn_email gn_cookie gn_account

	if { $gn_account == "" } {
		set gn_account $botnick
	}

	set string2 $string

	regsub -all xcookie $string2 $gn_cookie 	string2
	regsub -all xnick   $string2 $gn_account	string2
	regsub -all xpass   $string2 $gn_pass 		string2
	regsub -all xemail  $string2 $gn_email 		string2
	regsub -all xchan   $string2 $chan 		string2

	return $string2
}

# attempts to give the cookie to authserv
proc gn_needcookie { hand id args } {
	global gn_reqc1 gn_serviceaaddy

	putlog "GNTool: Giving cookie to $gn_serviceaaddy."
	set req_c2 [gn_stringsub $gn_reqc1 "none"]
	putserv "PRIVMSG $gn_serviceaaddy :$req_c2"

	return 0
}

proc gn_getauth { chan } {
	global gn_reqauth1 gn_serviceaaddy

	set service [gn_getserv $chan]

	if { [gn_needchan $chan] == 1 && $service != "none" } {
		set req_auth2 [gn_stringsub $gn_reqauth1 "none"]
		putserv "PRIVMSG $gn_serviceaaddy :$req_auth2"
	}

	return 0
}

# attempts to register the bot with gamesnet
proc gn_needreg { hand id args } {
	global bgn_reqreg1 gn_serviceaaddy

	putlog "GNTool: Requesting register from $gn_serviceaaddy."
	set req_reg2 [gn_stringsub $gn_reqreg1 "none"]	
	putserv "PRIVMSG $gn_serviceaaddy :$req_reg2"
	
	return 0
}

# attempts to unregister the bot with gamesnet
proc gn_needunreg { hand id args } {
	global gn_requnreg1 gn_serviceaaddy

	putlog "GNTool: Requesting register from $gn_serviceaaddy."
	set req_unreg2 [gn_stringsub $gn_requnreg1 "none"]
	putserv "PRIVMSG $gn_serviceaaddy :$req_unreg2"

	return 0
}

# requests an unban if needed
proc gn_needunban { chan args } {
	global gn_requnban1 gn_servicecaddy

	set service [gn_getserv $chan]

	if { [gn_needchan $chan] == 1 && $service != "none" } {
		putlog "GNTool: Requesting unban for $chan from $gn_servicecaddy."
		set req_unban2 [gn_stringsub $gn_requnban1 $chan]
		gn_getauth $chan
		putserv "PRIVMSG $service :$req_unban2"
	}

	return 0
}

# requests an un-key or un-limit if needed
proc gn_needkl { chan args } {
	global gn_reqlimkey1 gn_servicecaddy

	set service [gn_getserv $chan]

	if { [gn_needchan $chan] == 1 && $service != "none" } {
		putlog "GNTool: Requesting opening of $chan from $gn_servicecaddy."
		set req_limkey2 [gn_stringsub $gn_reqlimkey1 $chan]
		gn_getauth $chan
		putserv "PRIVMSG $service :$req_limkey2"
	}

	return 0
}

# requests and invite if it is need to join a chan
proc gn_needinvite { chan args } {
	global gn_reqinvite1 gn_servicecaddy

	set service [gn_getserv $chan]

	if { [gn_needchan $chan] == 1 && $service != "none" } {
		putlog "GNTool: Requesting invite for $chan from $gn_servicecaddy."
		set req_invite2 [gn_stringsub $gn_reqinvite1 $chan]
		gn_getauth $chan
		putserv "PRIVMSG $service :$req_invite2"
	}

	return 0
}

# requests auth when ops is needed
proc gn_needop { chan args } {
	global gn_reqop1 gn_servicecaddy

	set service [gn_getserv $chan]

	if { [gn_needchan $chan] == 1 && $service != "none" } { 
		putlog "GNTool: Requesting op for $chan from $gn_servicecaddy."
		set req_op2 [gn_stringsub $gn_reqop1 $chan]
		gn_getauth $chan
		putserv "PRIVMSG $service :$req_op2"
	}

	return 0
}

# defines the service for a chan, also branches timers
proc gn_setserv { chan } {
	global gn_servicename gn_servicecaddy gn_services gn_timers gn_servicecheck gn_chancheck gn_authrefresh

	set service_old [lindex [array get gn_services $chan] 1]

	if { [botonchan $chan] == 1 } {
		set gn_services($chan) "none"

		for { set x 0 } { $x < [llength [chanlist $chan]] } { incr x } {
			if { [lindex [chanlist $chan] $x] == $gn_servicename } {
				set gn_services($chan) $gn_servicecaddy
				if { $service_old != $gn_servicecaddy } { putlog "GNTool: Service for $chan set to $gn_servicename." }
			}
		}
	}

	# spawn this timer once for every chan
	if { [lindex [array get gn_timers $chan] 1] == "" } {
		set gn_timers($chan) 1
		utimer [expr $gn_servicecheck * 60] "gn_setserv $chan"
	}

	# spawn these timers only once
	# checkchanserv
	if { [lindex [array get gn_timers 0] 1] == "" } {
		set gn_timers(0) 1
		utimer $gn_chancheck "gn_checkchanserv"
	}

	# refreshauth
	if { [lindex [array get gn_timers 1] 1] == "" } {
		set gn_timers(1) 1
		utimer [expr $gn_authrefresh * 60] "gn_refreshauth $gn_servicename $chan" 
	}

	return 0
}

# returns the service name for a chan
proc gn_getserv { chan } {
	global gn_services

	set service [lindex [array get gn_services $chan] 1]

	if { $service == "" } { set service "none" }

	return $service
}

# refreshes auth with the services on a regular basis
proc gn_refreshauth { service chan } {
	global gn_services gn_authrefresh

	set service [lindex [array get gn_services $chan] 1]

	if { $service != "" } { gn_getauth $chan }

	utimer [expr $gn_authrefresh * 60] "gn_refreshauth $service $chan"

	return 0
}	

# calls the set service function after join
proc gn_needjoined { nick host hand chan } {
	global botnick

	if { $nick == $botnick && [gn_needchan $chan] == 1 } { utimer 20 "gn_setserv $chan" }

	return 0
}

putlog "GNTool script loaded... by Zsac v2.4.5"

# support for different bot nicks and account names added
# updated channel checking proc
# no more need for an ini file.
# ditched revenge stuff. didn't make sense
# removed gethost function. choked on brackets.
# new revenge type added
# unban bug fixed
# added function for subbing requests to chanserv. this way all variables are usable in the settings at the top of the file
# updated finduser with nick2hand function
# added help function
# fixed reg functions. added cookie command for when you have to issue
# 	those gay gamesnet cookies
# tweaked need functions to not trigger falsely
# fixed crazy needop error, not my fault. eggdrop is having trouble determining if its opped. gg
# fixed multiple timer problems
# todo
#	x.stop starting new checkchanserv timers on rehash
# fixed a bug with the service refresh if the bot isn't on the channel that it is refreshing
# updated a nasty bug with inidb and \'s
# added unregister command
# made variables more script specific
# added refresh auth timer
# to do: add a timer that refreshes auth, only one timer
# updated chattr commands to support +o handling the way the egg does it
# timer for chanserv +d check